# /bin/sh
# *****************************************************************
# *                                                               *
# *   Copyright 2009 Hewlett-Packard Development Company, L.P.    *
# *                                                               *
# *   crashdc may be copied only under the terms of the GNU       *
# *   General Public License, which may be found in the source    *
# *   kit.                                                        *
# *                                                               *
# *****************************************************************

KDUMPSUCCESS=$1
CRASHDCSUCCESS=0

if [[ -z $KDUMPSUCCESS ]];then
	KDUMPSUCCESS=0	# invoked from cmdline without $1
fi

if [[ -r /etc/sysconfig/crashdc ]];then
        . /etc/sysconfig/crashdc
else
        echo "The file /etc/sysconfig/crashdc is absent. Cannot run"
        exit 1
fi

coredir=`ls -rtd ${VMCOREDIR}/2* | cut -d\  -f2 | tail -1`

# Sometimes, kdump runs a PAE kernel even if the dumping kernel
# is Xen (See /etc/init.d/kdump for details). We must check vmcore
# to see if it is from Xen or not.


readelf -n $coredir/vmcore | grep -q VMCOREINFO_XEN
is_not_xen=$?
#if (( is_not_xen )) || [[ "$(arch)" == "x86_64" ]];then
if (( is_not_xen ));then
	kver=$(uname -r)
else
	kver=$(uname -r)
	kver=${kver%PAE}xen
fi
	namelist=/usr/lib/debug/lib/modules/${kver}/vmlinux

LOGGER="/usr/bin/logger -p info -t crashdc"

if ! [ -r $namelist ];then
	$LOGGER "Unable to locate $namelist. Verify that the kernel-debuginfo packages are correctly installed."
	exit 1
fi

case $CRASHMODE in
	BASIC ) CRASHMODE="-b";;
	ADVANCED ) CRASHMODE="-a";;
	CUSTOM ) true;;
	* ) echo "Invalid CRASHMODE value in /etc/sysconfig/crashdc : $CRASHMODE"
	exit 1;;
esac

if [ $KDUMPSUCCESS == 0 ];then
	$CRASHDC $CRASHDCDEBUG $CRASHMODE $namelist $coredir/vmcore $coredir
	CRASHDCSUCCESS=$?
	if [ $CRASHDCSUCCESS == 0 ];then
		$LOGGER "generated a crash-data file to $coredir"
		exit 0
	else
		$LOGGER "Unable to generate a crash-data file"
		exit 1
	fi
fi
